'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Immutable = require('immutable');

var IS_NOT_ASKED = 'isNotAsked';
var IS_FETCHING = 'isFetching';
var IS_SUCCESS = 'isSuccess';
var IS_ERROR = 'isError';
var DATA = 'data';
var ERROR = 'error';

var RequestState = function RequestState(existingState) {
    var _defaultState;

    var defaultState = (_defaultState = {}, _defineProperty(_defaultState, IS_NOT_ASKED, true), _defineProperty(_defaultState, IS_FETCHING, false), _defineProperty(_defaultState, IS_SUCCESS, false), _defineProperty(_defaultState, IS_ERROR, false), _defineProperty(_defaultState, DATA, null), _defineProperty(_defaultState, ERROR, null), _defaultState);

    this.state = existingState != null ? Immutable.Map(_extends(defaultState, existingState)) : Immutable.Map(defaultState);
};
RequestState.prototype.get = function () {
    return new RequestState(this.state.toJS());
};
RequestState.prototype.fetching = function () {
    this.state = this.state.update(function (s) {
        return s.set(DATA, null).set(IS_NOT_ASKED, false).set(IS_FETCHING, true).set(IS_ERROR, false).set(IS_SUCCESS, false);
    });
    return new RequestState(this.state.toJS());
};
RequestState.prototype.success = function (data) {
    this.state = this.state.update(function (s) {
        return s.set(DATA, data).set(IS_NOT_ASKED, false).set(IS_FETCHING, false).set(IS_ERROR, false).set(IS_SUCCESS, true);
    });
    return new RequestState(this.state.toJS());
};
RequestState.prototype.error = function (err) {
    this.state = this.state.update(function (s) {
        return s.set(DATA, null).set(ERROR, err).set(IS_NOT_ASKED, false).set(IS_FETCHING, false).set(IS_ERROR, true).set(IS_SUCCESS, false);
    });
    return new RequestState(this.state.toJS());
};
RequestState.prototype.isFetching = function () {
    return this.state.get(IS_FETCHING);
};
RequestState.prototype.isSuccess = function () {
    return this.state.get(IS_SUCCESS);
};
RequestState.prototype.isError = function () {
    return this.state.get(IS_ERROR);
};
RequestState.prototype.isNotAsked = function () {
    return this.state.get(IS_NOT_ASKED);
};

RequestState.prototype.getError = function () {
    return this.state.get(ERROR);
};
RequestState.prototype.getData = function () {
    return this.state.get(DATA);
};

module.exports = RequestState;